# -*- coding:cp932 -*-

import sys
import win32com.client
#COMNX̃CX^X쐬A}N萔(constants)pbP[WC|[g
from win32com.client import Dispatch, constants
#FemtetCOMNX`W[C|[g
from FemtetClassConst import FemtetClassName as const


#Main֐
def FemtetMain():
    global Femtet    #Femtetϐ͕ʊ֐ŗp̂globalϐƂĒ`
    
    Femtet = Dispatch(const.CFemtet) #CFemtetNX̃CX^X쐬
    
    #VKvWFNg
    if Femtet.OpenNewProject() == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    #f[^x[X̐ݒ
    AnalysisSetUp()
    BodyAttributeSetUp()
    MaterialSetUp()
    BoundarySetUp()
    
    MakeModel() #f̍쐬
    
    Femtet.Gaudi.MeshSize = 2 #WbVTCY̐ݒ
    
    Femtet.Gaudi.Mesh() #bV̐
    Femtet.Solve() #͂̎s
    
    #͌ʂ̒o
    SamplingResult() 


def AnalysisSetUp():
    #print("AnalysisSetUp")
    
    global Femtet #globalFemtetϐ𗘗p
    Als = Femtet.Analysis #͏NX
    
    #͏(Common)
    Als.AnalysisType = constants.COULOMB_C
    
    #JE(Open)
    Als.Open.OpenMethod = constants. ABC_C

    #bV̐ݒ(MeshProperty) 
    Als.MeshProperty.bIsoParamElement = True
    Als.MeshProperty.bMeshG2 = True

def BodyAttributeSetUp():
    #print("BodyAttributeSetUp")
    
    #Body̐ݒ
    BodyAttributeSetUp_Outside()
    BodyAttributeSetUp_Sub1()
    BodyAttributeSetUp_Sub2()


def BodyAttributeSetUp_Outside():
    #print("BodyAttributeSetUp_Outside")
    
    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX
    
    #Body̒ǉ
    BodyAttr.Add("Outside")
    
    #Body Index̐ݒ
    Index = BodyAttr.Ask("Outside")
    
    #V[g{fB̌ or 2͂̉s(BodyThickness)/C[{fB(WireWidth)
    BodyAttr.Length(Index).bUseAnalysisThickness2D = False
    BodyAttr.Length(Index).BodyThickness = 1e-3

    
def BodyAttributeSetUp_Sub1():
    #print("BodyAttributeSetUp")

    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX

    #Body̒ǉ
    BodyAttr.Add("Sub1")

    #Body Index̐ݒ
    Index = BodyAttr.Ask("Sub1")

    #V[g{fB̌ or 2͂̉s(BodyThickness)/C[{fB(WireWidth)
    BodyAttr.Length(Index).bUseAnalysisThickness2D = False

def BodyAttributeSetUp_Sub2():
    #print("BodyAttributeSetUp")

    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX

    #Body̒ǉ
    BodyAttr.Add("Sub2")

    #Body Index̐ݒ
    Index = BodyAttr.Ask("Sub2")

    #V[g{fB̌ or 2͂̉s(BodyThickness)/C[{fB(WireWidth)
    BodyAttr.Length(Index).bUseAnalysisThickness2D = False

def MaterialSetUp():
    #print("MaterialSetUp")
    
    #Material̐ݒ
    MaterialSetUp_Alumina()
    MaterialSetUp_AIR()


def MaterialSetUp_Alumina():
    #print("MaterialSetUp_Alumina")
    
    global Femtet #globalFemtetϐ𗘗p 
    Mtl = Femtet.Material #ޗ萔NX
    
    #Material̒ǉ
    Mtl.Add("Alumina")
 
    #Material Index̐ݒ
    Index = Mtl.Ask("Alumina")

    #Ud(Permittivity) 
    Mtl.Permittivity(Index).sEps = (10)



def MaterialSetUp_AIR():
    #print("MaterialSetUp_AIR")
    
    global Femtet #globalFemtetϐ𗘗p
    Mtl = Femtet.Material #ޗ萔NX

   #Material̒ǉ
    Mtl.Add ("AIR")


    #Material Index̐ݒ
    Index = Mtl.Ask("AIR") 


def BoundarySetUp():
    #print("BoundarySetUp")
    
    #Boundary̐ݒ
    BoundarySetUp_RESERVED_default()
    BoundarySetUp_V1()
    BoundarySetUp_V2()
    BoundarySetUp_Earth()

def BoundarySetUp_RESERVED_default():
    #print("BoundarySetUp_RESERVED_default")
    
    global Femtet #globalFemtetϐ𗘗p
    Bnd = Femtet.Boundary #ENX
    
    #Boundary̒ǉ
    Bnd.Add("RESERVED_default")
    
    #Boundary Index̐ݒ
    Index = Bnd.Ask("RESERVED_default")
    
    #(FluidBern)
    Bnd.FluidBern(Index).bSpline = False


def BoundarySetUp_V1():
    #print("BoundarySetUp_V1")
    
    global Femtet #globalFemtetϐ𗘗p
    Bnd = Femtet.Boundary #ENX
    
    #Boundary̒ǉ
    Bnd.Add("V1")
    
    #Boundary Index̐ݒ
    Index = Bnd.Ask("V1")
    
    #dC(Electrical)
    Bnd.Electrical(Index).Condition = constants.ELECTRIC_WALL_C
    Bnd.Electrical(Index).V = 1

def BoundarySetUp_V2():
    #print("BoundarySetUp_V2")
    
    global Femtet #globalFemtetϐ𗘗p
    Bnd = Femtet.Boundary #ENX
    
    #Boundary̒ǉ
    Bnd.Add("V2")
    
    #Boundary Index̐ݒ
    Index = Bnd.Ask("V2")
    
    #dC(Electrical)
    Bnd.Electrical(Index).Condition = constants.ELECTRIC_WALL_C
    Bnd.Electrical(Index).V = 2

def BoundarySetUp_Earth():
    #print("BoundarySetUp_Earth")
    
    global Femtet #globalFemtetϐ𗘗p
    Bnd = Femtet.Boundary #ENX
    
    #Boundary̒ǉ
    Bnd.Add("Earth")
    
    #Boundary Index̐ݒ
    Index = Bnd.Ask("Earth")
    
    #dC(Electrical)
    Bnd.Electrical(Index).Condition = constants.ELECTRIC_WALL_C
    Bnd.Electrical(Index).V = 0



def MakeModel():
    #print("MakeModel")
    
    global Femtet #globalFemtetϐ𗘗p
    Gaudi = Femtet.Gaudi #f[NX    
    BodyList = [] #Bodyzϐ̒`
    
    #f`悳Ȃݒ
    Femtet.RedrawMode = False

  
    #CreateBox
    Point0 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point0.SetCoord(0, 0, 0)
    tmpBody = Gaudi.CreateBox(Point0, 10, 10, 1)
    BodyList.append(tmpBody) #Xgɒǉ

    #CreateBox
    Point1 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point1.SetCoord(0, 0, 1)
    tmpBody = Gaudi.CreateBox(Point1, 10, 10, 1)
    BodyList.append(tmpBody) #Xgɒǉ

    #CreateBox
    Point2 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point2.SetCoord(0, 0, 2)
    tmpBody = Gaudi.CreateBox(Point2, 10, 10, 2)
    BodyList.append(tmpBody) #Xgɒǉ

    #CreateRect
    Point3 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point3.SetCoord(3.5, 3, 1)
    tmpBody = Gaudi.CreateRect(Point3, 3, 7)
    BodyList.append(tmpBody) #Xgɒǉ

    #CreateRect
    Point4 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point4.SetCoord(3.5, 0, 2)
    tmpBody = Gaudi.CreateRect(Point4, 3, 7)
    BodyList.append(tmpBody) #Xgɒǉ

 
    #SetName
    BodyList[1].SetName("Sub1", "Alumina")

    #SetName
    BodyList[0].SetName("Sub2", "Alumina")

    #SetName
    BodyList[2].SetName("Outside", "AIR")


    #SetBoundary
    Face0 = BodyList[3].GetFaceByID(9)
    Face0.AddBoundary("V1")

    #SetBoundary
    Face1 = BodyList[4].GetFaceByID(9)
    Face1.AddBoundary("V2")

    #SetBoundary
    Face2 = BodyList[0].GetFaceByID(9)
    Face2.AddBoundary("Earth")

    #BodyColor
#    Gaudi.MultiSetBodyColor BodyArray[0], &HFFFF80
    
    #fĕ`悵܂
    Femtet.Redraw()


def SamplingResult():
    #print("SamplingResult")
    
    global Femtet #globalFemtetϐ𗘗p
    Gogh = Femtet.Gogh #͌ʃNX
    
    Femtet.SavePDT(Femtet.ResultFilePath + ".pdt", True) #pdtt@Cۑ܂
    Femtet.OpenPDT(Femtet.ResultFilePath + ".pdt", True) #pdtt@CJ܂
       
    #tB[h̐ݒ
    Gogh.Coulomb.Vector = constants.COULOMB_ELECTRIC_C
    #xNg\
    Gogh.bVector = True

    #eʂ̎擾
    Data1 = Gogh.Coulomb.GetC("V1", "V2")
    Data2 = Gogh.Coulomb.GetC("V1", "Earth")
    Data3 = Gogh.Coulomb.GetC("V2", "Earth")

    #eʂ̌ʂWo͂ɕ\
    print("Capasitance Result\n [V1-V2] : %e\n [V1-Earth]  :%e\n [V2-Earth] :%e\n "  % (Data1,Data2,Data3))
    
# Main֐̎s
if __name__ == '__main__':
    FemtetMain()

