# -*- coding:cp932 -*-

import sys
import win32com.client
#COMNX̃CX^X쐬A}N萔(constants)pbP[WC|[g
from win32com.client import Dispatch, constants
#FemtetCOMNX`W[C|[g
from FemtetClassConst import FemtetClassName as const


#Main֐
def FemtetMain():
    global Femtet    #Femtetϐ͕ʊ֐ŗp̂globalϐƂĒ`
    
    Femtet = Dispatch(const.CFemtet) #CFemtetNX̃CX^X쐬
    
    #VKvWFNg
    if Femtet.OpenNewProject() == False:
        print(Femtet.LastErrorMsg)
        sys.exit()
    #f[^x[X̐ݒ
    AnalysisSetUp()
    BodyAttributeSetUp()
    MaterialSetUp()
    BoundarySetUp()
    
    MakeModel() #f̍쐬
    
    Femtet.Gaudi.MeshSize = 2 #WbVTCY̐ݒ
    
    Femtet.Gaudi.Mesh() #bV̐

    Femtet.Solve() #͂̎s
    
    SamplingResult() #͌ʂ̒o


def AnalysisSetUp():
    #print("AnalysisSetUp")
    
    global Femtet #globalFemtetϐ𗘗p
    Als = Femtet.Analysis #͏NX
    
    #͏(Common)
    Als.AnalysisType = constants.GAUSS_C
    
    #------- (Gauss) -------
    Als.Gauss.b2ndEdgeElement = True

    #------- bV̐ݒ(MeshProperty) -------
    Als.MeshProperty.bAutoAir = True
    Als.MeshProperty.AutoAirMeshSize = 18.0
    Als.MeshProperty.bChangePlane = True
    Als.MeshProperty.bMeshG2 = True

def BodyAttributeSetUp():
    #print("BodyAttributeSetUp")
    
    #Body̐ݒ
    BodyAttributeSetUp_coil()
    BodyAttributeSetUp_core()


def BodyAttributeSetUp_coil():
    
    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX
    
    #Body̒ǉ
    BodyAttr.Add("coil")
    
    #Body Index̐ݒ
    Index = BodyAttr.Ask("coil")

    #------- d(Current) -------
    BodyAttr.Current(Index).I = 1
    BodyAttr.Current(Index).N = 100

    #------- g`(Waveform) -------
    BodyAttr.Current(Index).CurrentDirType = constants.COIL_LOOP_HDIRECTION_C
    
def BodyAttributeSetUp_core():

    global Femtet #globalFemtetϐ𗘗p
    BodyAttr = Femtet.BodyAttribute #{fBNX

    #Body̒ǉ
    BodyAttr.Add("core")

    #Body Index̐ݒ
    Index = BodyAttr.Ask("core")

def MaterialSetUp():
    
    #Material̐ݒ
    MaterialSetUp_core()
    MaterialSetUp_cu()


def MaterialSetUp_core():
    
    global Femtet #globalFemtetϐ𗘗p 
    Mtl = Femtet.Material #ޗ萔NX
    
    #Material̒ǉ
    Mtl.Add("core")
 
    #Material Index̐ݒ
    Index = Mtl.Ask("core")

    #------- (Permeability) -------
    Mtl.Permeability(Index).sMu = 5000
    Mtl.Permeability(Index).BHExtrapolationType = constants.BH_GRADIENT_LASTTWOPOINT_C

    #------- (Magnetize) -------
    Mtl.Magnetize(Index).MagRatioType = constants.MAGRATIO_BR_C


def MaterialSetUp_cu():
    
    global Femtet #globalFemtetϐ𗘗p
    Mtl = Femtet.Material #ޗ萔NX

    #Material̒ǉ
    Mtl.Add ("cu")

    #Material Index̐ݒ
    Index = Mtl.Ask("cu") 

    #------- (Permeability) -------
    Mtl.Permeability(Index).BHExtrapolationType = constants.BH_GRADIENT_LASTTWOPOINT_C

    #------- R(Resistivity) -------
    Mtl.Resistivity(Index).sRho = 1.66666666666667e-8

    #------- d(ElectricConductivity) -------
    Mtl.ElectricConductivity(Index).ConductorType = constants.CONDUCTOR_C
    Mtl.ElectricConductivity(Index).sSigma = 6.0e7

    #------- (Magnetize) -------
    Mtl.Magnetize(Index).MagRatioType = constants.MAGRATIO_BR_C



def BoundarySetUp():
    
    #Boundary̐ݒ
    BoundarySetUp_RESERVED_default()

def BoundarySetUp_RESERVED_default():
    
    global Femtet #globalFemtetϐ𗘗p
    Bnd = Femtet.Boundary #ENX
    
    #Boundary̒ǉ
    Bnd.Add("RESERVED_default")
    
    #Boundary Index̐ݒ
    Index = Bnd.Ask("RESERVED_default")
    
    #------- dC(Electrical) -------
    Bnd.Electrical(Index).Condition = constants.ELECTRIC_WALL_C 


def MakeModel():
    #print("MakeModel")
    
    global Femtet #globalFemtetϐ𗘗p
    Gaudi = Femtet.Gaudi #f[NX    
    BodyList = [] #Bodyzϐ̒`
    
    #f`悳Ȃݒ
    Femtet.RedrawMode = False

    #------- CreateCylinder -------
    #Set Body(0) = Gaudi.CreateCylinder(Point0, 8.0, 30.0)

    Point0 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point0.SetCoord(0, 0, 0)
    tmpBody = Gaudi.CreateCylinder(Point0, 8.0, 30.0)
    BodyList.append(tmpBody) #Xgɒǉ

    #------- SetPlane -------
    Plane0 = Dispatch(const.CGaudiPlane) #CGaudiPlaneNX̃CX^X쐬
    Plane0.Location.SetCoord( 0.0, 0.0, 0.0)
    Plane0.MainDirection.SetCoord( 0.0, 1.0, 0.0)
    Plane0.RefDirection.SetCoord( 0.0, 0.0, 1.0)
    Gaudi.SetPlane( Plane0)

    #------- CreateRect -------
    Point1 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point1.SetCoord(9, 0, 5)
    tmpBody = Gaudi.CreateRect(Point1, 20, 3)
    BodyList.append(tmpBody) #Xgɒǉ

    #------- Spin -------
    Point2 = Dispatch(const.CGaudiPoint) #CGaudiPointNX̃CX^X쐬
    Point2.SetCoord(0, 0, 0)
    Vector0 = Dispatch(const.CGaudiVector) #CGaudiVectorNX̃CX^X쐬
    Vector0.SetCoord(0, 0, 1)
    BodyList[1].Spin( Point2, Vector0, 360)

    #------- SetName -------
    BodyList[1].SetName("coil", "cu")

    #------- SetName -------
    BodyList[0].SetName("core", "core")
    
    #fĕ`悵܂
    Femtet.Redraw()


def SamplingResult():
    
    global Femtet #globalFemtetϐ𗘗p
    Gogh = Femtet.Gogh #͌ʃNX
    
    Femtet.SavePDT(Femtet.ResultFilePath + ".pdt", True) #pdtt@Cۑ܂
    Femtet.OpenPDT(Femtet.ResultFilePath + ".pdt", True) #pdtt@CJ܂
       
    #tB[h̐ݒ
    Gogh.Gauss.Vector = constants.GAUSS_MAGNETIC_FLUX_DENSITY_C
    #xNg\
    Gogh.bVector = True

    #C_N^XL1̎擾
    Data = Gogh.Gauss.GetL("coil coil_InAuto coil_OutAuto", "coil coil_InAuto coil_OutAuto")

    #eʂ̌ʂWo͂ɕ\
    print("Inductance Result\n [L1] : %e\n "  % (Data))
    
# Main֐̎s
if __name__ == '__main__':
    FemtetMain()

